summit/urls.py
# The Summit Scheduler web application
# Copyright (C) 2008 - 2013 Ubuntu Community, Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls.defaults import *
from django.conf import settings

from common.views import login_failure

from django.contrib import admin
#admin.autodiscover()

urlpatterns = patterns(
    '',
    url(r'^$', 'summit.common.views.index', name="index"),
    (r'^admin/', admin.site.urls),
    (r'^api/', include('services.urls')),
)

urlpatterns += patterns(
    'django_openid_auth.views',
    url(r'^openid/login/$', 'login_begin', name='openid-login',
        kwargs={'render_failure': login_failure}),
    url(r'^openid/complete/$', 'login_complete', name='openid-complete',
        kwargs={'render_failure': login_failure}),
    url(r'^openid/logo.gif$', 'logo', name='openid-logo'),
)

urlpatterns += patterns(
    '',
    url(r'', include('social.apps.django_app.urls', namespace='social')),
)

urlpatterns += patterns(
    'summit.schedule.views',
    url(r'^today/(?P<summit_name>[\w-]+)/$', 'today_view', name='today'),
    url(r'^past/', 'past', name='past'),
    url(r'^logout$', 'logout_view', name='logout'),
    url(r'^(?P<summit_name>[\w-]+)/$', 'summit', name='summit'),
    url(r'^(?P<summit_name>[\w-]+)/mobile/$', 'mobile', name='mobile'),
    (r'^(?P<summit_name>[\w-]+)/search/$', 'search'),
    url(
        r'^(?P<summit_name>[\w-]+)/registration/$',
        'registration_form',
        name='registration',
    ),
    (r'^(?P<summit_name>[\w-]+)/propose_meeting/$', 'propose_meeting'),
    (r'^(?P<summit_name>[\w-]+)/edit_meeting/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'edit_meeting'),
    (r'^(?P<summit_name>[\w-]+)/review/$', 'review_pending'),
    url(
        r'^(?P<summit_name>[\w-]+)/all/$',
        'all_meetings',
        name='all_meetings',
    ),
    (r'^(?P<summit_name>[\w-]+)/review_meeting/(?P<meeting_id>\d+)/$',
     'meeting_review'),
    url(r'^(?P<summit_name>[\w-]+)/attend_meeting/(?P<meeting_id>\d+)/$',
     'attend_meeting', name='attend_meeting'),
    (r'^(?P<summit_name>[\w-]+)/edit_attendee/(?P<meeting_id>\d+)/(?P<username>[%+\.\w-]+)/$',
     'organizer_edit_attendees'),
    (r'^(?P<summit_name>[\w-]+)/create_meeting/$', 'create_meeting'),
    (r'^(?P<summit_name>[\w-]+)/edit_mtg/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'organizer_edit_meeting'),
    (r'^(?P<summit_name>[\w-]+)/hangout/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'edit_meeting_hangout'),
    (r'^(?P<summit_name>[\w-]+)/confirm_del_mtg/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'delete_meeting_confirm'),
    (r'^(?P<summit_name>[\w-]+)/del_mtg/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'delete_meeting'),
    (r'^(?P<summit_name>[\w-]+)/deleted/$', 'delete_confirmed'),
    (r'^(?P<summit_name>[\w-]+)/attendee_review/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'attendee_review'),
    (r'^(?P<summit_name>[\w-]+)/tracks$', 'tracks'),
    (r'^(?P<summit_name>[\w-]+)/next$', 'next_session'),
    (r'^(?P<summit_name>[\w-]+)/next_table$', 'next_table'),
    (r'^(?P<summit_name>[\w-]+)/(?P<username>[%+\.\w-]+)/meetings$',
     'created_meetings'),
    url(r'^(?P<summit_name>[\w-]+)/(?P<date>[\d-]+)/$', 'daily_schedule', name='daily_schedule'),
    url(r'^(?P<summit_name>[\w-]+)/grid/$', 'grid_schedule', name='grid_schedule'),
    url(r'^(?P<summit_name>[\w-]+)/grid/(?P<date>[\d-]+)/$', 'grid_date', name='grid_date'),
    url(r'^(?P<summit_name>[\w-]+)/grid/(?P<date>[\d-]+)/plain/$', 'grid_date_plain', name='grid_date_plain'),
    url(r'^(?P<summit_name>[\w-]+)/grid/today/$', 'grid_today', name='grid_today'),
    (r'^(?P<summit_name>[\w-]+)/(?P<date>[\d-]+)/display$', 'by_date'),
    (r'^(?P<summit_name>[\w-]+)/(?P<room_name>[%+\.\w-]+)/$', 'by_room'),
    (r'^(?P<summit_name>[\w-]+)/track/(?P<track_slug>[%+\.\w-]+)/$',
     'by_track'),
    (r'^(?P<summit_name>[\w-]+)/meeting/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/\+share$',
     'share_meeting'),
    (r'^(?P<summit_name>[\w-]+)/meeting/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/\+register',
     'register'),
    (r'^(?P<summit_name>[\w-]+)/meeting/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/\+unregister',
     'unregister'),
    url(r'^(?P<summit_name>[\w-]+)/meeting/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/$',
     'meeting', name='meeting'),
    (r'^(?P<summit_name>[\w-]+)/private/(?P<private_key>[0-9a-f]{32})/(?P<meeting_slug>[%+\.\w-]+)/$',
     'private_meeting'),
    (r'^(?P<summit_name>[\w-]+)/meeting/(?P<meeting_id>\d+)/(?P<meeting_slug>[%+\.\w-]+)/copy/$',
     'meeting_copy'),
    (r'^(?P<summit_name>[\w-]+)\.csv$', 'csv'),
    (r'^(?P<summit_name>[\w-]+)\.ical$', 'ical'),
    (r'^(?P<summit_name>[\w-]+)\.xml$', 'xml'),
    (r'^(?P<summit_name>[\w-]+)/participant/(?P<username>[%+\.\w-]+)/$',
     'by_participant'),
    (r'^(?P<summit_name>[\w-]+)/participant/my_schedule_(?P<secret_key>[0-9a-f]{32})\.ical$',
     'user_private_ical'),
    (r'^(?P<summit_name>[\w-]+)/participant/(?P<username>[%+\.\w-]+)\.ical$',
     'user_ical'),
    (r'^(?P<summit_name>[\w-]+)/room/(?P<room_name>[%+\.\w-]+).ical$',
     'room_ical'),
    (r'^(?P<summit_name>[\w-]+)/track/(?P<track_slug>[%+\.\w-]+).ical$',
     'track_ical'),
)

if settings.DEBUG or settings.SERVE_STATIC:
    urlpatterns += patterns(
        '',
        (r'^media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^(robots.txt)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^ubuntu-website/media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.THEME_MEDIA}),
    )

summit/schedule/models/leadmodel.py
# The Summit Scheduler web application
# Copyright (C) 2008 - 2013 Ubuntu Community, Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.db import models

from django.contrib.auth.models import User

from summit.schedule.models.summitmodel import Summit
from summit.schedule.models.trackmodel import Track
from summit.schedule.models.attendeemodel import Attendee

__all__ = (
    'Lead',
)


class Lead(models.Model):
    summit = models.ForeignKey(Summit)
    track = models.ForeignKey(Track)
    lead = models.ForeignKey(Attendee, related_name='lead')

    class Meta:
        app_label = 'schedule'
        ordering = ('summit', 'track')

summit/schedule/models/meetingmodel.py
# The Summit Scheduler web application
# Copyright (C) 2008 - 2013 Ubuntu Community, Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import re
import urllib2
from urlparse import urlparse
from datetime import datetime

from django.conf import settings
from django.db import models
from django.core.exceptions import ObjectDoesNotExist
from django.core.urlresolvers import reverse

import simplejson as json
from summit.schedule.fields import NameField

from summit.schedule.models.summitmodel import Summit
from summit.schedule.models.eventtypemodel import EventType
from summit.schedule.models.trackmodel import Track
from summit.schedule.models.attendeemodel import Attendee

from summit.schedule.autoslug import AutoSlugMixin

__all__ = (
    'Meeting',
)


class Meeting(AutoSlugMixin, models.Model):

    class SchedulingError(Exception):
        pass

    TYPE_CHOICES = (
        (u'discussion', u'Discussion'),
        (u'boardroom', u'Boardroom'),
        (u'plenary', u'Plenary'),
        (u'roundtable', u'Roundtable'),
        (u'workshop', u'Workshop'),
        (u'presentation', u'Presentation'),
        (u'panel', u'Panel Discussion'),
        (u'seminar', u'Seminar'),
        (u'special', u'Special Event'),
        (u'bof', u'BoF'),
    )

    TYPE_ICONS = {
        u'discussion': None,
        u'boardroom': None,
        u'plenary': None,
        u'roundtable': 'meeting_emblem_roundtable.png',
        u'workshop': 'meeting_emblem_workshop.png',
        u'presentation': 'meeting_emblem_presentation.png',
        u'panel': 'meeting_emblem_panel.png',
        u'seminar': None,
        u'special': None,
        u'bof': 'meeting_emblem_bof.png',
    }

    STATUS_CHOICES = (
        (u'NEW', u'New'),
        (u'DISCUSSION', u'Discussion'),
        (u'DRAFT', u'Drafting'),
        (u'PENDINGREVIEW', u'Review'),
        (u'PENDINGAPPROVAL', u'Pending Approval'),
        (u'APPROVED', u'Approved'),
        (u'SUPERSEDED', u'Superseded'),
        (u'OBSOLETE', u'Obsolete'),
    )

    PRIORITY_CHOICES = (
        (5, u'Undefined'),
        (10, u'Low'),
        (50, u'Medium'),
        (70, u'High'),
        (90, u'Essential'),
    )

    REVIEW_CHOICES = (
        (u'PENDING', u'Pending'),
        (u'APPROVED', u'Approved'),
        (u'DECLINED', u'Declined'),
        (u'REMOVED', u'Removed'),
    )

    DURATION_CHOICES = (
        (u"45m", u"45 min"),
        (u"20m", "20 min"),
        (u"xx", "other"),
    )

    summit = models.ForeignKey(Summit)
    name = NameField(
        max_length=100,
        help_text="Lowercase alphanumeric characters and dashes only."
    )
    title = models.CharField(
        max_length=100,
        help_text="Alphanumeric characters and spaces are allowed"
    )
    description = models.TextField(max_length=2047)
    notes = models.TextField(
	max_length=2047,
	verbose_name="Notes for Content Team (Optional; any private information you want to pass to the content team: scheduling, co-presenters, etc)",
        null=True,
        blank=True
    )
    eventtype = models.ForeignKey(EventType,
        verbose_name="Event type, you most likely want to submit a Talk or a BoF")
    type = models.CharField(
        max_length=15,
        choices=TYPE_CHOICES,
        default=TYPE_CHOICES[0][0]
    )
    status = models.CharField(
        max_length=50,
        choices=STATUS_CHOICES,
        null=True,
        blank=True
    )
    priority = models.IntegerField(
        choices=PRIORITY_CHOICES,
        null=True,
        blank=True
    )
    hangout_url = models.URLField(
        blank=True,
        null=True,
        help_text="URL for participation essential users to join the hangout",
        verify_exists=False,
    )
    broadcast_url = models.URLField(
        blank=True,
        null=True,
        help_text="URL for all other participants to watch the hangout",
        verify_exists=False,
    )
    # FIXME tracks must be for the same summit
    # (will require js magic in admin to refresh the boxes)
    tracks = models.ManyToManyField(
        Track,
        verbose_name=getattr(settings, 'TRACK_DISPLAY_NAME', 'Track'),
        blank=True
    )
    spec_url = models.URLField(
        blank=True,
        verbose_name="Spec URL"
    )
    wiki_url = models.URLField(
        blank=True,
        verify_exists=False,
        verbose_name="Wiki URL"
    )
    pad_url = models.URLField(
        verify_exists=False,
        verbose_name="Pad URL",
        null=True,
        blank=True
    )
    urls = models.TextField(
        blank=True,
        verbose_name="URLs that give extra information about your event"
    )
    # set by video team
    video_url = models.URLField(
        blank=True,
        null=True,
        help_text="URL of (non-life) video",
        verify_exists=False,
    )
    # set by video team / content team [from git annex]
    slides_url = models.URLField(
        blank=True,
        null=True,
        help_text="URL of final slides",
        verify_exists=False,
    )
    duration = models.CharField(verbose_name="Duration of the event",
        max_length=10, default="45 min", blank=True,
        choices=DURATION_CHOICES)
    slots = models.IntegerField(default=1)
    override_break = models.BooleanField(
        default=False,
        verbose_name="Override Break",
        help_text="If this is a multi-slot meeting, should it be"
        "allowed to take place during a break"
    )
    virtual_meeting = models.BooleanField(
        help_text="If virtual summit is true, this will not override it"
    )
    approved = models.CharField(
        max_length=10,
        choices=REVIEW_CHOICES,
        null=True,
        default='PENDING'
    )
    private = models.BooleanField(default=False)
    private_key = models.CharField(max_length=32, null=True, blank=True)

    requires_dial_in = models.BooleanField(
        verbose_name="Dial in",
        help_text="This session requires dial in availability"
    )
    video = models.BooleanField(
        verbose_name="Video recording desired/permitted",
        help_text="This session could be videotaped",
        default=True
    )

    # FIXME attendees must be for the same summit
    # (will require js magic in admin to refresh the boxes)
    drafter = models.ForeignKey(
        Attendee,
        verbose_name="Submitter",
        null=True,
        blank=True,
        related_name='drafter_set'
    )
    assignee = models.ForeignKey(
        Attendee,
        null=True,
        blank=True,
        related_name='assignee_set'
    )
    approver = models.ForeignKey(
        Attendee,
        null=True,
        blank=True,
        related_name='approver_set'
    )
    scribe = models.ForeignKey(
        Attendee,
        null=True,
        blank=True,
        related_name='scribe_set'
    )
    speakers = models.ManyToManyField(
        Attendee,
	verbose_name="Speakers/Coordinators/Moderators",
        blank=True,
	related_name='speaker_set'
    )
    participants = models.ManyToManyField(
        Attendee,
        blank=True,
        through='Participant'
    )
    launchpad_blueprint_id = models.IntegerField(blank=True, null=True)

    class Meta:
        app_label = 'schedule'

    def save(self, *args, **kwargs):
        super(Meeting, self).save(*args, **kwargs)
        self.update_slug()

    def get_decription(self):
        return self.description or ''

    def share(self):
        if not self.pk or not self.private:
            return

        if not self.private_key:
            import hashlib
            import random
            meeting_hash = hashlib.md5()
            meeting_hash.update(str(self.pk))
            meeting_hash.update(self.name)
            meeting_hash.update(str(random.random()))
            self.private_key = meeting_hash.hexdigest()
            self.save()
        return self.private_key

    def _etherpadise_string(self, string):
        return re.sub(r"[^a-zA-Z0-9\-]", '-', string)

    def get_link_to_pad(self):
        if self.pad_url is not None and self.pad_url != '':
            return self.pad_url
        elif self.private:
            import hashlib
            import random
            meeting_hash = hashlib.md5()
            meeting_hash.update(str(self.pk))
            meeting_hash.update(self.name)
            meeting_hash.update(str(random.random()))
            pad_host = self.summit.etherpad
            self.pad_url = '%(host)s%(summit)s-%(meeting)s' % {
                'host': pad_host,
                'summit': self.summit.name,
                'meeting': meeting_hash.hexdigest(),
            }
            self.save()
            return self.pad_url
        else:
            pad_host = self.summit.etherpad
            name = self._etherpadise_string(self.name)
            return '%(host)s%(summit)s-%(meeting)s' % {
                'host': pad_host,
                'summit': self.summit.name,
                'meeting': name,
            }
    link_to_pad = property(get_link_to_pad)

    def get_edit_link_to_pad(self):
        if self.pad_url is not None and self.pad_url != '':
            return self.pad_url
        else:
            pad_host = self.summit.etherpad
            name = self._etherpadise_string(self.name)
            return '%(host)sep/pad/view/%(summit)s-%(meeting)s/latest' % {
                'host': pad_host,

summit/schedule/templates/schedule/_grid.html
<table class="calendar calendar-grid table table-bordered">
    <thead>
        <tr>
            <th class="time">&nbsp;</th>
            {% for room in timetable.rooms %}<th>{{ room }}</th>{% endfor %}
        </tr>
    </thead>
    <tbody>
        {% for time, row in timetable.rows.items %}
            <tr class="schedule_grid_{{time.1|stringformat:"02i"}}"{% if row.hidden %} style="display:hidden;"{% endif %}>
              {% if not row.hidden %}
                {% if time.1|divisibleby:"15" %}<td class="time" rowspan="3">{{ time.0 }}:{{time.1|stringformat:"02i"}}</td>{% endif %}
                {% if row.slot.type == "end" %}
                    <td colspan="{{ timetable.rooms|length }}"><em>Feierabend!</em></td>
                {% else %}
                {% for cell in row.list %}
                    {% if cell != "ignore" %}
                    <td class="slot" colspan="1" rowspan="{{ cell.duration }}"{% if cell.bgcolor %} style="background-color:#{{ cell.bgcolor }}"{% endif %}>
                            {% if not cell %}
                                <span></span>
                            {% elif cell.meal %}
                                <span class="grid-meal">{{ cell.meal }}</span>
                            {% else %}
                                <span class="grid-title">
                                    <a href="{{ cell.talk.get_meeting_page_url }}">{{ cell.talk.title|truncatechars:64 }}</a>
                                </span>
                                <span class="grid-speaker">
                                    <small>{{ cell.speakers }}</small>
                                </span>
                            {% endif %}
                    </td>
                    {% endif %}
                {% endfor %}
                {% endif %}
              {% endif %}
            </tr>
        {% endfor %}
    </tbody>
</table>

summit/schedule/templates/schedule/actions.html
{% load schedule_perms %}

{% ifnotequal summit.state "public" %}
<div class="box box-padded">
    <h3>Quick Links</h3>
    <div>
        <ul class="list">
            
    <li><a href="{% url all_meetings summit.name %}">All events</a></li>
    {% if summit_organizer %}
        <li><a href="/{{ summit.name }}/create_meeting" title="Create an Event">Create an event</a></li>
        <li><a href="/{{ summit.name }}/review" title="Review Proposed Events">Review proposed events</a></li>
    {% else %}
        <li class="propose"><a href="/{{ summit.name }}/propose_meeting">Propose an event</a></li>
    {% endif %}
    {% if attendee %}
        <li><a href="{% url summit.schedule.views.created_meetings summit.name attendee.user.username %}">My proposed events</a></li>
    {% endif %}

{% ifchangeschedule summit attendee %}
    {% if schedule.date %}
        <li><a href="/{{ summit.name }}/{{schedule.date|date:'Y-m-d'}}/display?edit">Schedule events</a></li>
    {% else %}
        {% if viewdate %}
            <li><a href="/{{ summit.name }}/{{viewdate|date:'Y-m-d'}}/display?edit">Schedule events</a></li>
        {% else %}
            <li><a href="/{{ summit.name }}/{{summit.date_start|date:'Y-m-d'}}/display?edit">Schedule events</a></li>
        {% endif %}
    {% endif %}
{% endifchangeschedule %}

{% ifequal summit.state "sponsor" %}
    <li><a href="/{{ summit.name }}/sponsorship">Request sponsorship</a></li>
    {% if perms.sponsor.add_sponsorshipsuggestion %}
        <li><a href="/{{ summit.name }}/suggestsponsorship">Suggest sponsorship</a></li>
    {% endif %}
{% else %}
    {% if not user.is_authenticated %}
        <p><a href="{{login_url}}?next={{login_next}}">Log in now</a></p>
    {% endif %}
{% endifequal %}

{% if summit.state == "review" or summit.state == "sponsor" %}
    {% if perms.sponsor.add_sponsorshipscore %}
        <li><a href="/{{ summit.name }}/sponsorship/review">Review sponsorship requests</a></li>
    {% endif %}
{% endif %}

{% if attendee %}
    <li><a href="{% url registration summit.name %}">Update registration</a></li>
{% endif %}
    </ul>
</div>
</div>

{% endifnotequal %}

summit/schedule/templates/schedule/attend.html
{% extends "base.html" %}

{% block page_name %}Attend {{ meeting }} - {{ summit.title }}{%endblock %}
{% block sub_nav %}{% endblock %}

{% block closure %}
<script type="text/javascript"><!--
$(document).ready(function(){
    $('span[rel*=help]').colorTip({color:'orange'});
});
--></script>
{% endblock %}


{% block content %}
<div class="row">
    <article id="form" class="span-8">
        {% if form.errors %}
            <p style="color: red;">
                Please correct the error{{ form.errors|pluralize }} below.
            </p>
        {% endif %}

        <form action="{{ request.path_info }}" method="POST">{% csrf_token %}
            <fieldset>
                <h3>Attend "{{ meeting.title }}"</h3>
                {{ form.as_template }}
		{% if meeting.drafter.name == meeting.approver.name %}
                <p id="twitter_update_list" style="color: black;">If you feel that your participation is required for this topic, please contact {{ meeting.approver.name }}, otherwise, please select one of the options above.</p>
		{% else %}
                <p id="twitter_update_list" style="color: black;">If you feel that your participation is required for this topic, please contact {{ meeting.drafter.name }} or {{ meeting.approver.name }}, otherwise, please select one of the options above.</p>
		{% endif %}
                {% if is_popup %}<input type="hidden" name="_popup" value="1">{% endif %}
                <input type="submit" name="submit" value="Save" class="submit-button" />
            </fieldset>
        </form>
    </article>
</div>
{% endblock %}

summit/schedule/templates/schedule/review.html
{% extends "base.html" %}

{% block page_name %}
Review Proposed Events - {{ summit.title }}
{% endblock %}

{% block extrahead %}
{{ block.super }}
<style>
TABLE img.icon {
    vertical-align: bottom;
    width: 16px;
    height: 16px;
}

table.basic span.main-agenda-item-tracks {
    font-size: 0.8em;
}

div.agenda-details {
    display: none;
    padding: 5px;
    position: absolute;
    margin-left: 20px;
    font-size: 0.9em;
    color: #FFFFFF;
    background-color: #101010;
    border: #000000 1px solid;
    border-radius: 5px;
    min-width: 200px;
    max-width: 500px;
    z-index: 100;
}

div.meeting-description {
    white-space: pre-wrap;
}

div.agenda-details LI {
    font-size: 1.0em;
}

div.schedule-head {
    position: relative;
    overflow: visible;
    z-index: 10;
}

div.schedule-head .schedule-qrcode {
    height: 63px;
    vertical-align: top;
    margin-left: -3px;
    margin-top: -3px;
}

div.schedule-head .schedule-date {
    font-weight: normal;
    font-size: 36px;
    margin-left: 5px;
}

div.schedule-head .schedule-crew, .last-updated {
    font-size: 0.7pc;
}

</style>
{% endblock %}

{% block sub_nav %}
{% endblock %}

{% block content %}
<div class="row">
<article class="span-12">

{% for track, meetings in schedule.items %}
<div class="schedule-head">
    <h2>{{ track.title }}</h2>
</div>
<table class="basic">
{% for meeting in meetings %}
<tr style="background-color: {{ meeting.track_color }}; {% if meeting.private %}border: 1px; border-style: solid; border-color: #FF0000;{% endif %}">
<td width="75%">
    <span onMouseOver="show_meeting_details({{meeting.id}});" onMouseOut="hide_meeting_details({{meeting.id}});">
    <a href="{{ meeting.meeting_page_url }}" style="color: #000000;" class="main-agenda-item-name">
        {{ meeting.title }} -- {{ meeting.drafter.name }}
    </a>
<div id="meeting-{{meeting.id}}-details" class="agenda-details">
<div class="arrow"></div>
<div class="meeting-description">
Speaker: {{meeting.drafter.name}}<br />
{{meeting.description}}</div>
{% if meeting.participant_set.count %}
<br /><b>Participants:</b>
<div>{% for participant in meeting.participant_set.all %}
    <div>
        {% if participant.required %}
        <img class="icon" src="/media/img/required.png" title="required" alt="(required)">
        {% else %}
        <img class="icon" src="/media/img/attending.png" alt="attending">
        {% endif %}{{ participant.attendee.user }}</div>
{% endfor %}</div>
{% endif %}
{% if meeting.tracks.count > 0 %}
<br /><b>Tracks:</b>
<ul>{% for track in meeting.tracks.all %}
    <li style="color: #{{track.color}};">{{ track.title }}</li>
{% endfor %}</ul>
{% endif %}
</div>
</td>
<td width="25%">
<a href="{% url summit.schedule.views.meeting_review summit.name meeting.id %}">Status: {{ meeting.get_approved_display }}</a>
</td>
</tr>
{% endfor %}
</table>
{% endfor%}
</article>
</div>
{% block closure %}

<script language="JavaScript">

function show_meeting_details(meeting_id) {
    var elem_id = 'meeting-'+meeting_id+'-details'
    var details = document.getElementById(elem_id)
    details.style.display='block';
}

function hide_meeting_details(meeting_id) {
    var elem_id = 'meeting-'+meeting_id+'-details'
    var details = document.getElementById(elem_id)
    details.style.display='none';
}

</script>
{% endblock %}

{% endblock %}